# Closure problems on graphs

Bare-bones Python package for solving closure problems on directed graphs. Package also include a class for solving Hochbaum's normalized cut (HNC) on an undirected graph.

## Installation
Use `pip` to install the package:
```bash
    pip install closure-problem
```

## Example
See `tests` folder for examples.

## Further Reading
* [UC Berkeley IEOR 266 lecture notes](https://hochbaum.ieor.berkeley.edu/files/IEOR266-lecturenotes-2018.pdf)
* [DS Hochbaum (2013). A polynomial time algorithm for rayleigh ratio on discrete variables: Replacing spectral techniques for expander ratio, normalized cut, and cheeger constant. Operations Research, 61(1), 184-198.](https://hochbaum.ieor.berkeley.edu/html/pub/spectralOR2013.pdf)
